<?xml version='1.0'?>
<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <!-- TODO:
                Add in ?rev=number args to URLs if <sv revision> is set.
                                                             -->
    <xsl:output
        method="xml"
        version = "1.0"
        encoding="utf-8"
        omit-xml-declaration="no"
        indent="yes"
        doctype-public="-//W3C//DTD XHTML 1.1//EN"
        doctype-system="http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd"
        media-type="text/html" />

    <xsl:template match='/'>
        <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
            <head>
                <!-- TODO: Change the Title with the Action and Path -->
                <title>SVN View</title>
                <link rel="stylesheet" href="{sv/@basedir}/*theme*/style.css" type="text/css" />
            </head>
            <body>
                <div id="sv_top">
                    <div id="sv_top_title"><a href="http://www.outoforder.cc/projects/apache/mod_svn_view/">mod_svn_view <xsl:value-of select="sv/@version" /></a></div>
                    <div id="sv_top_repos_switch">
                        <form method="get" action="{sv/@basedir}">
                        <fieldset>
                            <input type="hidden" name="action" value="redirect"/>
                            <label>Repositories:
                                <select name="repo">
                                    <xsl:apply-templates select="sv/repos/repo" />
                                </select>
                            </label>
                            <input type="submit" value="go" />
                        </fieldset>
                        </form>
                    </div>
                </div>
                <div id="sv_body_break">
                    <br/>
                </div>
                <div id="sv_body">
                    <div id="sv_title">
                        <!-- TODO: Make this Reflect the Actual Action! -->
                        <h1>SVN View</h1>
                    </div>
                    <div id="sv_content">
                        <xsl:choose>
                            <xsl:when test="sv/@action = 'list_repos'">
                                <table id="sv_repo_list_table">
                                    <tr>
                                        <th>Repository</th>
                                        <th>Description</th>
                                    </tr>

                                    <xsl:for-each select='sv/repos/repo'>
                                        <tr>
                                            <td><a href="{/sv/@basedir}/{@short_name}/"><xsl:value-of select="@short_name"/></a></td>
                                            <td><pre><xsl:value-of select="desc"/></pre></td>
                                        </tr>
                                    </xsl:for-each>
                                </table>
                            </xsl:when>
                            <xsl:when test="sv/@action = 'view_history'">
                                <div id="sv_breadcrumbs">
                                        <xsl:call-template name="generateBreadcrumb">
                                            <xsl:with-param name="basePath" select="sv/@basedir"/>
                                            <xsl:with-param name="repoName" select="sv/@repo"/>
                                            <xsl:with-param name="completePath" select="sv/file/@name"/>
                                        </xsl:call-template>
                                </div>
                                <p>File History</p>
                                <table id="sv_last_history">
                                    <tr>
                                        <th class="sv_th">Revision</th>
                                        <th class="sv_th">Time</th>
                                        <th class="sv_th">Info</th>
                                    </tr>
                                    <xsl:for-each select='sv/file/history/revision'>
                                    <tr>
                                       <td valign="top">[<a href="{/sv/@basedir}/{/sv/@repo}?ci={@id}"><xsl:value-of select="@id"/></a>]</td>
                                       <td valign="top"><xsl:value-of select="date"/><br/>
                                           [<a href="?action=view_udiff&amp;r1={@id}&amp;r2=TRUNK">diff to TRUNK</a>]<br/>
                                           <xsl:choose>
                                               <xsl:when test='/sv/file/history/diff/@d1 = @id'>
                                                  [Selected]
                                               </xsl:when>
                                               <xsl:otherwise>
                                               [<a href="?action=view_history&amp;d1={@id}">Select for diff</a>]<br/>
                                               <xsl:choose>
                                                   <xsl:when test='/sv/file/history/diff/@d1'>
                                                   [<a href="?action=view_udiff&amp;r1={/sv/file/history/diff/@d1}&amp;r2={@id}">
                                                    diff to <xsl:value-of select="/sv/file/history/diff/@d1"/></a>]<br/>
                                                   </xsl:when>
                                               </xsl:choose>
                                               </xsl:otherwise>
                                            </xsl:choose>
                                       </td>
                                       <td  valign="top">
                                           Author: <xsl:value-of select="author"/><br/>
                                           Log: <pre><xsl:value-of select="log"/></pre>
                                           [<a href="{/sv/@basedir}/{/sv/@repo}?ci={@id}">View Details</a>]
                                       </td>
                                    </tr>
                                    </xsl:for-each>
                                </table>
                            </xsl:when>
                            <xsl:when test="sv/@action = 'view_commit'">
                                <div id="sv_breadcrumbs">
                                        <xsl:call-template name="generateBreadcrumb">
                                            <xsl:with-param name="basePath" select="sv/@basedir"/>
                                            <xsl:with-param name="repoName" select="sv/@repo"/>
                                            <xsl:with-param name="completePath" select="sv/file/@name"/>
                                        </xsl:call-template>
                                </div>
                                <p>
                                [<a href="{/sv/@basedir}/{/sv/@repo}?ci={sv/commit/@rev - 1}">&lt;&lt;</a>]
                                Revision <xsl:value-of select="sv/commit/@rev"/>
                                [<a href="{/sv/@basedir}/{/sv/@repo}?ci={sv/commit/@rev + 1}">&gt;&gt;</a>]</p>

                                <table id="sv_last_history">
                                    <xsl:for-each select='sv/commit/revision'>
                                    <tr>
                                        <th class="sv_th">Revision: </th>
                                        <td valign="top"><xsl:value-of select="@id"/></td>
                                    </tr>
                                    <tr>
                                        <th valign="top" class="sv_th">Date: </th>
                                        <td valign="top"><xsl:value-of select="date"/>
                                       </td>
                                    </tr>
                                    <tr>
                                       <th valign="top" class="sv_th">Author: </th>
                                       <td  valign="top">
                                           <xsl:value-of select="author"/>
                                       </td>
                                    </tr>
                                    <tr>
                                       <th valign="top" class="sv_th">Log: </th>
                                       <td  valign="top"><pre>
                                           <xsl:value-of select="log"/>
                                       </pre></td>
                                    </tr>
                                    <tr>
                                       <th valign="top" class="sv_th">Changes: </th>
                                       <td  valign="top"><br/>
                                    <xsl:for-each select='modfiles/modfile'>
                                        <xsl:value-of select="@action"/>
                                        <xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>
                                        <xsl:value-of select="@path"/><br/>
                                    </xsl:for-each>
                                       </td>
                                    </tr>
                                    </xsl:for-each>
                                </table>
                                <a href="?action=view_rss"><img src="{/sv/@basedir}/*theme*/rss.gif" alt="RSS Feed"/></a>
                            </xsl:when>
                            <xsl:when test="sv/@action = 'view_inline'">
                                <div id="sv_breadcrumbs">
                                        <xsl:call-template name="generateBreadcrumb">
                                            <xsl:with-param name="basePath" select="sv/@basedir"/>
                                            <xsl:with-param name="repoName" select="sv/@repo"/>
                                            <xsl:with-param name="completePath" select="sv/file/@name"/>
                                        </xsl:call-template>
                                </div>
                                <div id="sv_actions">
                                    [<a href="?action=view_blame">Blame</a>]
                                    [<a href="?action=view_history">History</a>]
                                    [<a href="?action=view_file">Download</a>]
                                </div>
                                <table id="sv_last_history">
                                    <tr>
                                        <th colspan="2" class="sv_th">Revision Information</th>
                                    </tr>
                                    <tr>
                                        <td class="sv_td_title_1" valign="top">Revision: </td>
                                        <td class="sv_td_value_1"><xsl:value-of select='sv/file/@revision'/></td>
                                    </tr>
                                    <tr>
                                        <td class="sv_td_title_0" valign="top">Last Modification: </td>
                                        <td class="sv_td_value_0"><xsl:value-of select='sv/file/date'/></td>
                                    </tr>
                                    <tr>
                                        <td class="sv_td_title_1" valign="top">Author: </td>
                                        <td class="sv_td_value_1"><xsl:value-of select='sv/file/author'/></td>
                                    </tr>
                                    <tr>
                                        <td class="sv_td_title_0" valign="top">Log: </td>
                                        <td class="sv_td_value_0"><pre><xsl:value-of select='sv/file/log'/></pre></td>
                                    </tr>

                                </table>
                                   <div id="sv_view_inline_content">
                                <xsl:choose>
                                    <xsl:when test="sv/file/contents/@type = 'text'">
                                        <xsl:copy-of select='sv/file/contents/*'/>
                                    </xsl:when>
                                    <xsl:when test="sv/file/contents/@type = 'image'">
                                        <img src="?action=view_file" />
                                    </xsl:when>
                                    <xsl:otherwise>
                                        This Type of Content is not viewable inline.<br/>
                                        [<a href="?action=view_file">Download</a>]
                                    </xsl:otherwise>
                                </xsl:choose>
                                   </div>
                                <xsl:apply-templates select="sv/file/properties" />
                                <a href="?action=view_rss"><img src="{/sv/@basedir}/*theme*/rss.gif" alt="RSS Feed"/></a>
                            </xsl:when>
                            <xsl:when test="sv/@action = 'view_dir'">
                                <div id="sv_breadcrumbs">
                                        <xsl:call-template name="generateBreadcrumb">
                                            <xsl:with-param name="basePath" select="sv/@basedir"/>
                                            <xsl:with-param name="repoName" select="sv/@repo"/>
                                            <xsl:with-param name="completePath" select="sv/dirlist/@name"/>
                                        </xsl:call-template>
                                </div> <br/>
                                <table width="100%" id="sv_file_table">
                                  <tr>
                                      <th> </th>
                                      <th>Name</th>
                                      <th>Rev.</th>
                                      <th>User</th>
                                      <th>Log</th>
                                  </tr>
                                <xsl:for-each select='sv/dirlist/node'>
                                    <xsl:sort select="@type"/>
                                    <xsl:variable name="rowclass">
                                        <xsl:choose>
                                            <xsl:when test="position() mod 2 = 1">sv_list_even</xsl:when>
                                            <xsl:otherwise>sv_list_odd</xsl:otherwise>
                                        </xsl:choose>
                                   </xsl:variable>
                                   <tr><xsl:attribute name="class"><xsl:value-of select="$rowclass"/></xsl:attribute>
                                        <td>
                                            <!-- TODO: Put Pretty Icons here -->
                                            <xsl:choose>
                                                <xsl:when test="@type = 'dir'">
                                                    <img src="{/sv/@basedir}/*theme*/folder1.png" alt=""/>
                                                </xsl:when>
                                                <xsl:when test="@type = 'file'">
                                                    <img src="{/sv/@basedir}/*theme*/text.png" alt=""/>
                                                </xsl:when>
                                                <xsl:otherwise>[other?]</xsl:otherwise>
                                            </xsl:choose> 
                                        </td>
                                        <td>
                                            <xsl:choose>
                                                <xsl:when test="@type = 'dir'">
                                                    <a href="{@name}/"><xsl:value-of select='@name' /></a>
                                                </xsl:when>
                                                <xsl:when test="@type = 'file'">
                                                    <a href="{@name}"><xsl:value-of select='@name' /></a>
                                                </xsl:when>
                                            </xsl:choose>
                                        </td>
                                        <td>
                                        <a href="{/sv/@basedir}/{/sv/@repo}?ci={@revision}"><xsl:value-of select="@revision" /></a></td>
                                        <td><xsl:value-of select="author" /></td>
                                        <td><xsl:choose>
                                            <xsl:when test="string-length(log) &lt;= 25">
                                                <xsl:value-of select="log" />
                                            </xsl:when>
                                            <xsl:otherwise>
                                                <xsl:value-of select="concat(substring(log,1,25),'...')" />
                                            </xsl:otherwise>
                                        </xsl:choose>
                                        </td>
                                    </tr>
                                </xsl:for-each>
                                </table>
                                <xsl:apply-templates select="sv/dirlist/properties" />
                                <a href="?action=view_rss"><img src="{/sv/@basedir}/*theme*/rss.gif" alt="RSS Feed"/></a>
                            </xsl:when>
                            <xsl:otherwise>
                                <div id="sv_error">Error:<br/>Invalid Action Passed</div>
                            </xsl:otherwise>
                        </xsl:choose>
                    </div>
                </div>
            </body>
        </html>
    </xsl:template>
    <xsl:template match='repo'>
        <option xmlns="http://www.w3.org/1999/xhtml" value="{@short_name}"><xsl:value-of select='@short_name'/></option>
    </xsl:template>
    <xsl:template match='properties'>
        <table xmlns="http://www.w3.org/1999/xhtml" class="sv_property_table">
            <tr class="sv_property_header">
                <th>Property</th>
                <th>Value</th>
            </tr>
            <xsl:choose>
                <xsl:when test="@count = 0">
                    <tr>
                        <td colspan="2">[no properties set]</td>
                    </tr>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:for-each select='prop'>
                        <tr valign="top" class="sv_property_row">
                            <td><xsl:value-of select='@name'/></td>
                            <td><xsl:value-of select='@value'/></td>
                        </tr>
                    </xsl:for-each>
                </xsl:otherwise>
            </xsl:choose>
        </table>
    </xsl:template>

    <!-- The Following Templates are based off of http://www.takepart.com/xslt/breadcrumbGeneration.html -->
    <xsl:template name="generateBreadcrumb">
        <a xmlns="http://www.w3.org/1999/xhtml" href="{$basePath}">[Repo List]</a> - 
        <xsl:call-template name="generateBreadcrumbStep">
            <xsl:with-param name="basePath" select="$basePath"/>
            <xsl:with-param name="repoName" select="$repoName"/>
            <xsl:with-param name="completePath" select="$completePath"/>
            <xsl:with-param name="filePath" select="$completePath"/>
        </xsl:call-template>
    </xsl:template>
    <xsl:template name="generateBreadcrumbStep">
        <xsl:param name="basePath"/>
        <xsl:param name="repoName"/>
        <xsl:param name="completePath"/>
        <xsl:param name="filePath"/>
        <xsl:choose>
            <xsl:when test="contains($filePath,'/')">
			   <xsl:variable name="temppath" select="substring-after($filePath,'/')"/>
               <xsl:variable name="urlpath" select="substring-before($completePath,substring-after($filePath,'/'))" />
               <a xmlns="http://www.w3.org/1999/xhtml" href="{$basePath}/{$repoName}{$urlpath}">
                    <xsl:call-template name="checkName">
                        <xsl:with-param name="fileName">
                            <xsl:value-of select="substring-before($filePath,'/')"/>
                        </xsl:with-param>
                        <xsl:with-param name="repoName" select="$repoName"/>
                    </xsl:call-template>
                </a>
                <xsl:text>/</xsl:text>
                <xsl:call-template name="generateBreadcrumbStep">
                    <xsl:with-param name="basePath" select="$basePath"/>
                    <xsl:with-param name="repoName" select="$repoName"/>
                    <xsl:with-param name="completePath" select="$completePath"/>
                    <xsl:with-param name="filePath" select="substring-after($filePath,'/')"/>
                </xsl:call-template>
            </xsl:when>
            <xsl:otherwise> 
                <xsl:call-template name="checkName">
                    <xsl:with-param name="fileName">
                        <xsl:value-of select="concat(' ', $filePath)"/>
                    </xsl:with-param>
                    <xsl:with-param name="repoName" select="$repoName"/>
                </xsl:call-template>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template name="checkName">
        <xsl:param name="repoName"/>
        <xsl:param name="fileName"/>
        <xsl:choose>
            <xsl:when test="'' = $fileName">[<xsl:value-of select="$repoName"/>]</xsl:when>
            <xsl:otherwise>
                 <xsl:value-of select="$fileName"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>

</xsl:stylesheet>
